/* THIS FILE WAS GENERATED. DO NOT EDIT. */
#ifndef DF_ITEM_TYPE_H
#define DF_ITEM_TYPE_H
#ifdef __GNUC__
#pragma GCC system_header
#endif
namespace df {
  namespace enums {
    namespace item_type {
      enum item_type : int16_t {
        NONE = -1, // -1, 0xFFFFFFFFFFFFFFFF
        /**
         * Bars, such as metal, fuel, or soap.
         */
        BAR, // 0, 0x0
        /**
         * Cut gemstones usable in jewelers workshop
         */
        SMALLGEM, // 1, 0x1
        /**
         * Blocks of any kind.
         */
        BLOCKS, // 2, 0x2
        /**
         * Rough gemstones.
         */
        ROUGH, // 3, 0x3
        /**
         * Raw mined stone.
         */
        BOULDER, // 4, 0x4
        /**
         * Wooden logs.
         */
        WOOD, // 5, 0x5
        /**
         * Doors.
         */
        DOOR, // 6, 0x6
        /**
         * Floodgates.
         */
        FLOODGATE, // 7, 0x7
        /**
         * Beds.
         */
        BED, // 8, 0x8
        /**
         * Chairs and thrones.
         */
        CHAIR, // 9, 0x9
        /**
         * Restraints.
         */
        CHAIN, // 10, 0xA
        /**
         * Flasks.
         */
        FLASK, // 11, 0xB
        /**
         * Goblets.
         */
        GOBLET, // 12, 0xC
        /**
         * Musical instruments.
         */
        INSTRUMENT, // 13, 0xD
        /**
         * Toys.
         */
        TOY, // 14, 0xE
        /**
         * Glass windows.
         */
        WINDOW, // 15, 0xF
        /**
         * Cages.
         */
        CAGE, // 16, 0x10
        /**
         * Barrels.
         */
        BARREL, // 17, 0x11
        /**
         * Buckets.
         */
        BUCKET, // 18, 0x12
        /**
         * Animal traps.
         */
        ANIMALTRAP, // 19, 0x13
        /**
         * Tables.
         */
        TABLE, // 20, 0x14
        /**
         * Coffins.
         */
        COFFIN, // 21, 0x15
        /**
         * Statues.
         */
        STATUE, // 22, 0x16
        /**
         * Corpses. Does not have a material.
         */
        CORPSE, // 23, 0x17
        /**
         * Weapons.
         */
        WEAPON, // 24, 0x18
        /**
         * Armor and clothing worn on the upper body.
         */
        ARMOR, // 25, 0x19
        /**
         * Armor and clothing worn on the feet.
         */
        SHOES, // 26, 0x1A
        /**
         * Shields and bucklers.
         */
        SHIELD, // 27, 0x1B
        /**
         * Armor and clothing worn on the head.
         */
        HELM, // 28, 0x1C
        /**
         * Armor and clothing worn on the hands.
         */
        GLOVES, // 29, 0x1D
        /**
         * Chests (wood), coffers (stone), boxes (glass), and bags (cloth or leather).
         */
        BOX, // 30, 0x1E
        /**
         * Bins.
         */
        BIN, // 31, 0x1F
        /**
         * Armor stands.
         */
        ARMORSTAND, // 32, 0x20
        /**
         * Weapon racks.
         */
        WEAPONRACK, // 33, 0x21
        /**
         * Cabinets.
         */
        CABINET, // 34, 0x22
        /**
         * Figurines.
         */
        FIGURINE, // 35, 0x23
        /**
         * Amulets.
         */
        AMULET, // 36, 0x24
        /**
         * Scepters.
         */
        SCEPTER, // 37, 0x25
        /**
         * Ammunition for hand-held weapons.
         */
        AMMO, // 38, 0x26
        /**
         * Crowns.
         */
        CROWN, // 39, 0x27
        /**
         * Rings.
         */
        RING, // 40, 0x28
        /**
         * Earrings.
         */
        EARRING, // 41, 0x29
        /**
         * Bracelets.
         */
        BRACELET, // 42, 0x2A
        /**
         * Large gems.
         */
        GEM, // 43, 0x2B
        /**
         * Anvils.
         */
        ANVIL, // 44, 0x2C
        /**
         * Body parts. Does not have a material.
         */
        CORPSEPIECE, // 45, 0x2D
        /**
         * Dead vermin bodies. Material is CREATURE_ID:CASTE.
         */
        REMAINS, // 46, 0x2E
        /**
         * Butchered meat.
         */
        MEAT, // 47, 0x2F
        /**
         * Prepared fish. Material is CREATURE_ID:CASTE.
         */
        FISH, // 48, 0x30
        /**
         * Unprepared fish. Material is CREATURE_ID:CASTE.
         */
        FISH_RAW, // 49, 0x31
        /**
         * Live vermin. Material is CREATURE_ID:CASTE.
         */
        VERMIN, // 50, 0x32
        /**
         * Tame vermin. Material is CREATURE_ID:CASTE.
         */
        PET, // 51, 0x33
        /**
         * Seeds from plants.
         */
        SEEDS, // 52, 0x34
        /**
         * Plants.
         */
        PLANT, // 53, 0x35
        /**
         * Tanned skins.
         */
        SKIN_TANNED, // 54, 0x36
        /**
         * Assorted plant growths, including leaves and berries
         */
        PLANT_GROWTH, // 55, 0x37
        /**
         * Thread gathered from webs or made at the farmers workshop.
         */
        THREAD, // 56, 0x38
        /**
         * Cloth made at the loom.
         */
        CLOTH, // 57, 0x39
        /**
         * Skull totems.
         */
        TOTEM, // 58, 0x3A
        /**
         * Armor and clothing worn on the legs.
         */
        PANTS, // 59, 0x3B
        /**
         * Backpacks.
         */
        BACKPACK, // 60, 0x3C
        /**
         * Quivers.
         */
        QUIVER, // 61, 0x3D
        /**
         * Catapult parts.
         */
        CATAPULTPARTS, // 62, 0x3E
        /**
         * Ballista parts.
         */
        BALLISTAPARTS, // 63, 0x3F
        /**
         * Siege engine ammunition.
         */
        SIEGEAMMO, // 64, 0x40
        /**
         * Ballista arrow heads.
         */
        BALLISTAARROWHEAD, // 65, 0x41
        /**
         * Mechanisms.
         */
        TRAPPARTS, // 66, 0x42
        /**
         * Trap components.
         */
        TRAPCOMP, // 67, 0x43
        /**
         * Alcoholic drinks.
         */
        DRINK, // 68, 0x44
        /**
         * Powders such as flour, gypsum plaster, dye, or sand.
         */
        POWDER_MISC, // 69, 0x45
        /**
         * Pieces of cheese.
         */
        CHEESE, // 70, 0x46
        /**
         * Prepared meals. Subtypes come from item_food.txt
         */
        FOOD, // 71, 0x47
        /**
         * Liquids such as water, lye, and extracts.
         */
        LIQUID_MISC, // 72, 0x48
        /**
         * Coins.
         */
        COIN, // 73, 0x49
        /**
         * Fat, tallow, pastes/pressed objects, and small bits of molten rock/metal.
         */
        GLOB, // 74, 0x4A
        /**
         * Small rocks (usually sharpened and/or thrown in adventurer mode)
         */
        ROCK, // 75, 0x4B
        /**
         * Pipe sections.
         */
        PIPE_SECTION, // 76, 0x4C
        /**
         * Hatch covers.
         */
        HATCH_COVER, // 77, 0x4D
        /**
         * Grates.
         */
        GRATE, // 78, 0x4E
        /**
         * Querns.
         */
        QUERN, // 79, 0x4F
        /**
         * Millstones.
         */
        MILLSTONE, // 80, 0x50
        /**
         * Splints.
         */
        SPLINT, // 81, 0x51
        /**
         * Crutches.
         */
        CRUTCH, // 82, 0x52
        /**
         * Traction benches.
         */
        TRACTION_BENCH, // 83, 0x53
        /**
         * Casts
         */
        ORTHOPEDIC_CAST, // 84, 0x54
        /**
         * Tools.
         */
        TOOL, // 85, 0x55
        /**
         * Slabs.
         */
        SLAB, // 86, 0x56
        /**
         * Eggs. Material is CREATURE_ID:CASTE.
         */
        EGG, // 87, 0x57
        /**
         * Books.
         */
        BOOK, // 88, 0x58
        /**
         * Sheets of paper
         */
        SHEET, // 89, 0x59
        /**
         * Tree branches
         */
        BRANCH, // 90, 0x5A
      };
    }
  }
  using enums::item_type::item_type;
  template<> struct DFHACK_EXPORT identity_traits<item_type> {
    static enum_identity identity;
    static enum_identity *get() { return &identity; }
  };
  template<> struct DFHACK_EXPORT enum_traits<item_type> {
    static const bool is_complex = false;
    typedef int16_t base_type;
    typedef item_type enum_type;
    static const base_type first_item_value = -1;
    static const base_type last_item_value = 90;
    static inline bool is_valid(base_type value) {
      return (value >= first_item_value && value <= last_item_value);
    }
    static const enum_type first_item = (enum_type)first_item_value;
    static const enum_type last_item = (enum_type)last_item_value;
    static const char *const key_table[92];
    struct attr_entry_type {
      const char* caption;
      bool is_rawable;
      bool is_stackable;
      bool is_caste_mat;
      const char* classname;
      static struct_identity _identity;
    };
    static const attr_entry_type attr_table[92+1];
    static const attr_entry_type &attrs(enum_type value);
  };
}
#endif
